//------------------------------------------------------------------------------
// shape_Constr.cpp -     
//     
//------------------------------------------------------------------------------

#include <iostream>
#include "shape_atd.h"

//------------------------------------------------------------------------------

namespace simple_shapes {

//------------------------------------------------------------------------------

  //       
  //  . ,  ,    .

  void Init(rectangle &r, int x, int y);
  void Init(triangle &t, int a, int b, int c);

//------------------------------------------------------------------------------

  //    
  shape *Create_shape_rectangle(int x, int y)
  {
    r_shape *pr = new r_shape;
    pr->k = 1; // 
    Init(pr->r, x, y);
    return (shape*)pr;
  }

//------------------------------------------------------------------------------

  //    
  shape *Create_shape_triangle(int a, int b, int c)
  {
    t_shape *pt = new t_shape;
    pt->k = 2; // 
    Init(pt->t, a, b, c);
    return (shape*)pt;
  }

//------------------------------------------------------------------------------

  //   
  void Init_rectangle(r_shape &r, int x, int y)
  {
    r.k = 1; // 
    Init(r.r, x, y);
  }

//------------------------------------------------------------------------------

  //   
  void Init_triangle(t_shape &t, int a, int b, int c)
  {
    t.k = 2; // 
    Init(t.t, a, b, c);
  }

//------------------------------------------------------------------------------

  //     
  void Delete(shape *ps)
  {
    //     
    switch(ps->k)
    {
    case 1: // 
      delete (r_shape*)ps;
      break;
    case 2: // 
      delete (t_shape*)ps;
      break;
    }
  }

//------------------------------------------------------------------------------

} // end simple_shapes namespace
